io.input("input")

seeds = {}
nseeds = {}
ranges = {}
nranges = {}
mapi = 0

for line in io.lines() do
    if mapi == 0 then
        for s,r in line:gmatch("(%d+) (%d+)") do
            s = tonumber(s)
            r = tonumber(r)
            table.insert(ranges, {start=s, fin=s+r-1})
        end
    end

    if line:match("^$") then
        if mapi>0 then
            -- add new ranges for next iteration
            table.move(nranges, 1, #nranges, #ranges+1, ranges)
            nranges = {}
        end

        mapi = mapi + 1
        --print(mapi)
        goto continue 
    end

    if mapi==0 or line:match("^[%a%- ]+:$") then
        goto continue
    end

    dst, src, len = line:match("(%d+) (%d+) (%d+)")
    dsts = tonumber(dst)
    srcs = tonumber(src)
    len = tonumber(len)
    dstf = dsts+len-1
    srcf = srcs+len-1
    --print(dst, src, len, dsts, dstf, srcs, srcf)

    --transform
    nextranges = {}
    repeat
        range = table.remove(ranges)
        if range then
            ns = math.max( range.start, srcs )
            nf = math.min( range.fin, srcf )
            if ns <= nf then -- intersection
                --print("intersect")
                diff = nf - ns
                offsetsrcs = ns - srcs
                offsetdsts = dsts + offsetsrcs
                -- transform range
                transformed = {start=offsetdsts, fin=offsetdsts+diff}
                --print(ns, nf, "->", transformed.start, transformed.fin)
                table.insert(nranges, transformed)
                -- remainders?
                if range.start<ns then
                    keep = {start=range.start, fin=ns-1}
                    --print("keep", keep.start, keep.fin)
                    table.insert(nextranges, keep)
                end
                if range.fin>nf then
                    keep = {start=nf+1, fin=range.fin}
                    --print("keep", keep.start, keep.fin)
                    table.insert(nextranges, keep)
                end
            else --range stays as is
                table.insert(nextranges, range)
            end
        end
    until not range
    -- copy next ranges to ranges
    table.move(nextranges, 1, #nextranges, 1, ranges)

    ::continue::
end


table.sort(ranges, function(a,b) return a.start < b.start end)
--[[
for i,r in ipairs(ranges) do
    print(i, r.start, r.fin)
end
--]]

print("part 2", ranges[1].start)
